package crm

import (
	"hongze/fms_api/global"
	"time"
)

// ChartPermission CRM系统-权限表
type ChartPermission struct {
	ChartPermissionId   int       `gorm:"primaryKey;column:chart_permission_id" description:"权限ID"`
	ChartPermissionName string    `description:"名称"`
	PermissionName      string    `description:"权限名"`
	Sort                int       `description:"排序"`
	Enabled             int       `description:"是否可用"`
	CreatedTime         time.Time `description:"创建时间"`
	LastUpdatedTime     time.Time `description:"更新时间"`
	TeleconferenceSort  int       `description:"电话会类型排序"`
	Remark              string    `description:"备注"`
	ClassifyName        string    `description:"分类名称"`
	ProductName         string    `description:"产品名称"`
	ProductID           int       `description:"产品ID"`
	ImageURL            string    `description:"图片地址"`
	ShowType            int       `description:"1:查研观向小程序展示"`
	IsOther             int       `description:"是否是其他，用于查研观向小程序后台展示"`
	IsReport            int       `description:"是否是报告，用于查研观向小程序前台报告展示"`
	CygxAuth            int       `description:"是否是权限，用于查研观向小程序前台权限校验"`
	YbImgUrl            string    `description:"研报小程序报告列表icon"`
	PriceDrivenState    int       `description:"品种价格驱动开启状态 0-关闭 1-开启"`
}

type PermissionSetResp struct {
	List []*PermissionSetList
}

type PermissionSetList struct {
	ClassifyName string `description:"分类"`
	Items        []*PermissionSetItem
	CheckList    []int
}

type PermissionSetItem struct {
	ChartPermissionId int    `description:"权限id"`
	PermissionName    string `description:"权限名称"`
	PermissionType    int    `description:"1主观，2客观"`
	Checked           bool   `description:"选中状态"`
	ClassifyName      string `description:"分类名称"`
}

func GetPermissionSetItemsByCondition(condition string, pars []interface{}) (items []*PermissionSetItem, err error) {
	items = make([]*PermissionSetItem, 0)
	err = global.MYSQL["report"].Model(ChartPermission{}).
		Where(condition, pars...).
		Order("sort ASC").
		Find(&items).Error
	return
}

// ContractPermissionListReq CRM系统合同权限-列表请求体
type ContractPermissionListReq struct {
	ProductId int `json:"product_id" form:"product_id" binding:"omitempty" description:"产品: 1-FICC; 2-权益"`
}
